package it.sw.pa.comune.artegna.web.rest;

import static it.sw.pa.comune.artegna.domain.MessaggioAsserts.*;
import static it.sw.pa.comune.artegna.web.rest.TestUtil.createUpdateProxyForBean;
import static org.assertj.core.api.Assertions.assertThat;
import static org.hamcrest.Matchers.hasItem;
import static org.mockito.Mockito.*;
import static org.springframework.security.test.web.servlet.request.SecurityMockMvcRequestPostProcessors.csrf;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;

import com.fasterxml.jackson.databind.ObjectMapper;
import it.sw.pa.comune.artegna.IntegrationTest;
import it.sw.pa.comune.artegna.domain.Messaggio;
import it.sw.pa.comune.artegna.repository.MessaggioRepository;
import it.sw.pa.comune.artegna.service.MessaggioService;
import it.sw.pa.comune.artegna.service.dto.MessaggioDTO;
import it.sw.pa.comune.artegna.service.mapper.MessaggioMapper;
import jakarta.persistence.EntityManager;
import java.time.Instant;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import java.util.Random;
import java.util.concurrent.atomic.AtomicLong;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.http.MediaType;
import org.springframework.security.test.context.support.WithMockUser;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.transaction.annotation.Transactional;

/**
 * Integration tests for the {@link MessaggioResource} REST controller.
 */
@IntegrationTest
@ExtendWith(MockitoExtension.class)
@AutoConfigureMockMvc
@WithMockUser
class MessaggioResourceIT {

    private static final Instant DEFAULT_SPEDITO = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_SPEDITO = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final String DEFAULT_TESTO = "AAAAAAAAAA";
    private static final String UPDATED_TESTO = "BBBBBBBBBB";

    private static final Instant DEFAULT_LETTO = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_LETTO = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final String ENTITY_API_URL = "/api/messaggios";
    private static final String ENTITY_API_URL_ID = ENTITY_API_URL + "/{id}";

    private static Random random = new Random();
    private static AtomicLong longCount = new AtomicLong(random.nextInt() + (2L * Integer.MAX_VALUE));

    @Autowired
    private ObjectMapper om;

    @Autowired
    private MessaggioRepository messaggioRepository;

    @Mock
    private MessaggioRepository messaggioRepositoryMock;

    @Autowired
    private MessaggioMapper messaggioMapper;

    @Mock
    private MessaggioService messaggioServiceMock;

    @Autowired
    private EntityManager em;

    @Autowired
    private MockMvc restMessaggioMockMvc;

    private Messaggio messaggio;

    private Messaggio insertedMessaggio;

    /**
     * Create an entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Messaggio createEntity() {
        return new Messaggio().spedito(DEFAULT_SPEDITO).testo(DEFAULT_TESTO).letto(DEFAULT_LETTO);
    }

    /**
     * Create an updated entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Messaggio createUpdatedEntity() {
        return new Messaggio().spedito(UPDATED_SPEDITO).testo(UPDATED_TESTO).letto(UPDATED_LETTO);
    }

    @BeforeEach
    void initTest() {
        messaggio = createEntity();
    }

    @AfterEach
    void cleanup() {
        if (insertedMessaggio != null) {
            messaggioRepository.delete(insertedMessaggio);
            insertedMessaggio = null;
        }
    }

    @Test
    @Transactional
    void createMessaggio() throws Exception {
        long databaseSizeBeforeCreate = getRepositoryCount();
        // Create the Messaggio
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);
        var returnedMessaggioDTO = om.readValue(
            restMessaggioMockMvc
                .perform(
                    post(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(messaggioDTO))
                )
                .andExpect(status().isCreated())
                .andReturn()
                .getResponse()
                .getContentAsString(),
            MessaggioDTO.class
        );

        // Validate the Messaggio in the database
        assertIncrementedRepositoryCount(databaseSizeBeforeCreate);
        var returnedMessaggio = messaggioMapper.toEntity(returnedMessaggioDTO);
        assertMessaggioUpdatableFieldsEquals(returnedMessaggio, getPersistedMessaggio(returnedMessaggio));

        insertedMessaggio = returnedMessaggio;
    }

    @Test
    @Transactional
    void createMessaggioWithExistingId() throws Exception {
        // Create the Messaggio with an existing ID
        messaggio.setId(1L);
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);

        long databaseSizeBeforeCreate = getRepositoryCount();

        // An entity with an existing ID cannot be created, so this API call must fail
        restMessaggioMockMvc
            .perform(post(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(messaggioDTO)))
            .andExpect(status().isBadRequest());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeCreate);
    }

    @Test
    @Transactional
    void getAllMessaggios() throws Exception {
        // Initialize the database
        insertedMessaggio = messaggioRepository.saveAndFlush(messaggio);

        // Get all the messaggioList
        restMessaggioMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc"))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.[*].id").value(hasItem(messaggio.getId().intValue())))
            .andExpect(jsonPath("$.[*].spedito").value(hasItem(DEFAULT_SPEDITO.toString())))
            .andExpect(jsonPath("$.[*].testo").value(hasItem(DEFAULT_TESTO)))
            .andExpect(jsonPath("$.[*].letto").value(hasItem(DEFAULT_LETTO.toString())));
    }

    @SuppressWarnings({ "unchecked" })
    void getAllMessaggiosWithEagerRelationshipsIsEnabled() throws Exception {
        when(messaggioServiceMock.findAllWithEagerRelationships(any())).thenReturn(new PageImpl(new ArrayList<>()));

        restMessaggioMockMvc.perform(get(ENTITY_API_URL + "?eagerload=true")).andExpect(status().isOk());

        verify(messaggioServiceMock, times(1)).findAllWithEagerRelationships(any());
    }

    @SuppressWarnings({ "unchecked" })
    void getAllMessaggiosWithEagerRelationshipsIsNotEnabled() throws Exception {
        when(messaggioServiceMock.findAllWithEagerRelationships(any())).thenReturn(new PageImpl(new ArrayList<>()));

        restMessaggioMockMvc.perform(get(ENTITY_API_URL + "?eagerload=false")).andExpect(status().isOk());
        verify(messaggioRepositoryMock, times(1)).findAll(any(Pageable.class));
    }

    @Test
    @Transactional
    void getMessaggio() throws Exception {
        // Initialize the database
        insertedMessaggio = messaggioRepository.saveAndFlush(messaggio);

        // Get the messaggio
        restMessaggioMockMvc
            .perform(get(ENTITY_API_URL_ID, messaggio.getId()))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.id").value(messaggio.getId().intValue()))
            .andExpect(jsonPath("$.spedito").value(DEFAULT_SPEDITO.toString()))
            .andExpect(jsonPath("$.testo").value(DEFAULT_TESTO))
            .andExpect(jsonPath("$.letto").value(DEFAULT_LETTO.toString()));
    }

    @Test
    @Transactional
    void getNonExistingMessaggio() throws Exception {
        // Get the messaggio
        restMessaggioMockMvc.perform(get(ENTITY_API_URL_ID, Long.MAX_VALUE)).andExpect(status().isNotFound());
    }

    @Test
    @Transactional
    void putExistingMessaggio() throws Exception {
        // Initialize the database
        insertedMessaggio = messaggioRepository.saveAndFlush(messaggio);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the messaggio
        Messaggio updatedMessaggio = messaggioRepository.findById(messaggio.getId()).orElseThrow();
        // Disconnect from session so that the updates on updatedMessaggio are not directly saved in db
        em.detach(updatedMessaggio);
        updatedMessaggio.spedito(UPDATED_SPEDITO).testo(UPDATED_TESTO).letto(UPDATED_LETTO);
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(updatedMessaggio);

        restMessaggioMockMvc
            .perform(
                put(ENTITY_API_URL_ID, messaggioDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(messaggioDTO))
            )
            .andExpect(status().isOk());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertPersistedMessaggioToMatchAllProperties(updatedMessaggio);
    }

    @Test
    @Transactional
    void putNonExistingMessaggio() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        messaggio.setId(longCount.incrementAndGet());

        // Create the Messaggio
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restMessaggioMockMvc
            .perform(
                put(ENTITY_API_URL_ID, messaggioDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(messaggioDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithIdMismatchMessaggio() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        messaggio.setId(longCount.incrementAndGet());

        // Create the Messaggio
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restMessaggioMockMvc
            .perform(
                put(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(messaggioDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithMissingIdPathParamMessaggio() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        messaggio.setId(longCount.incrementAndGet());

        // Create the Messaggio
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restMessaggioMockMvc
            .perform(put(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(messaggioDTO)))
            .andExpect(status().isMethodNotAllowed());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void partialUpdateMessaggioWithPatch() throws Exception {
        // Initialize the database
        insertedMessaggio = messaggioRepository.saveAndFlush(messaggio);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the messaggio using partial update
        Messaggio partialUpdatedMessaggio = new Messaggio();
        partialUpdatedMessaggio.setId(messaggio.getId());

        partialUpdatedMessaggio.spedito(UPDATED_SPEDITO).letto(UPDATED_LETTO);

        restMessaggioMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedMessaggio.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedMessaggio))
            )
            .andExpect(status().isOk());

        // Validate the Messaggio in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertMessaggioUpdatableFieldsEquals(
            createUpdateProxyForBean(partialUpdatedMessaggio, messaggio),
            getPersistedMessaggio(messaggio)
        );
    }

    @Test
    @Transactional
    void fullUpdateMessaggioWithPatch() throws Exception {
        // Initialize the database
        insertedMessaggio = messaggioRepository.saveAndFlush(messaggio);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the messaggio using partial update
        Messaggio partialUpdatedMessaggio = new Messaggio();
        partialUpdatedMessaggio.setId(messaggio.getId());

        partialUpdatedMessaggio.spedito(UPDATED_SPEDITO).testo(UPDATED_TESTO).letto(UPDATED_LETTO);

        restMessaggioMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedMessaggio.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedMessaggio))
            )
            .andExpect(status().isOk());

        // Validate the Messaggio in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertMessaggioUpdatableFieldsEquals(partialUpdatedMessaggio, getPersistedMessaggio(partialUpdatedMessaggio));
    }

    @Test
    @Transactional
    void patchNonExistingMessaggio() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        messaggio.setId(longCount.incrementAndGet());

        // Create the Messaggio
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restMessaggioMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, messaggioDTO.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(messaggioDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithIdMismatchMessaggio() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        messaggio.setId(longCount.incrementAndGet());

        // Create the Messaggio
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restMessaggioMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(messaggioDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithMissingIdPathParamMessaggio() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        messaggio.setId(longCount.incrementAndGet());

        // Create the Messaggio
        MessaggioDTO messaggioDTO = messaggioMapper.toDto(messaggio);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restMessaggioMockMvc
            .perform(
                patch(ENTITY_API_URL).with(csrf()).contentType("application/merge-patch+json").content(om.writeValueAsBytes(messaggioDTO))
            )
            .andExpect(status().isMethodNotAllowed());

        // Validate the Messaggio in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void deleteMessaggio() throws Exception {
        // Initialize the database
        insertedMessaggio = messaggioRepository.saveAndFlush(messaggio);

        long databaseSizeBeforeDelete = getRepositoryCount();

        // Delete the messaggio
        restMessaggioMockMvc
            .perform(delete(ENTITY_API_URL_ID, messaggio.getId()).with(csrf()).accept(MediaType.APPLICATION_JSON))
            .andExpect(status().isNoContent());

        // Validate the database contains one less item
        assertDecrementedRepositoryCount(databaseSizeBeforeDelete);
    }

    protected long getRepositoryCount() {
        return messaggioRepository.count();
    }

    protected void assertIncrementedRepositoryCount(long countBefore) {
        assertThat(countBefore + 1).isEqualTo(getRepositoryCount());
    }

    protected void assertDecrementedRepositoryCount(long countBefore) {
        assertThat(countBefore - 1).isEqualTo(getRepositoryCount());
    }

    protected void assertSameRepositoryCount(long countBefore) {
        assertThat(countBefore).isEqualTo(getRepositoryCount());
    }

    protected Messaggio getPersistedMessaggio(Messaggio messaggio) {
        return messaggioRepository.findById(messaggio.getId()).orElseThrow();
    }

    protected void assertPersistedMessaggioToMatchAllProperties(Messaggio expectedMessaggio) {
        assertMessaggioAllPropertiesEquals(expectedMessaggio, getPersistedMessaggio(expectedMessaggio));
    }

    protected void assertPersistedMessaggioToMatchUpdatableProperties(Messaggio expectedMessaggio) {
        assertMessaggioAllUpdatablePropertiesEquals(expectedMessaggio, getPersistedMessaggio(expectedMessaggio));
    }
}
